# -*- coding:utf-8 -*-

"""
for Using to initialize the provider object
"""

import math
import json
import cx_Oracle
from pymongo import MongoClient
import mongo_operater
import zlib


def initial_providers():
    provider_list=[]
    conn = cx_Oracle.connect('you oracle tablespace user name/you orcale tablespace password@IP/orcl')
    cursor = conn.cursor()
    select_providers_sql = '''select objectid_1,point_x,point_y,doctor_count,hosiptal_name from childrenhospital t'''
    cursor.execute(select_providers_sql)
    rs = cursor.fetchall()
    for i, row in enumerate(rs):
        try:
            objectid_1 = row[0]
            point_x = row[1]
            point_y = row[2]
            doctor_count = row[3]
            hosiptal_name=row[4]
            provider={}
            provider["provider_id"]=objectid_1
            provider["x"]=point_x
            provider["y"]=point_y
            provider["dc"]=doctor_count
            provider["name"]=hosiptal_name
            #TP_T--->public transportation time
            #TP_D--->public transportation distance
            # D_T--->driving time
            # D_D--->driving distance
            # W_T--->walking time
            # W_D--->walking distance
            # B_T--->bicycling time
            # B_D--->bicycling distance
            provider["travel"]={"TP_T":999,"TP_D":999,"D_T":999,"D_D":999,"W_T":999,"W_D":999,"B_T":999,"B_D":999}
            provider_list.append(provider)
        except:
            continue
    return provider_list

def get_all_demonds_and_save_in_mongodb(provider_list,mongo_operater_obj):
    conn = cx_Oracle.connect('you oracle tablespace user name/you orcale tablespace password@IP/orcl')
    cursor = conn.cursor()
    select_demands_sql = '''select objectid,DJZQDM,sum_actura,Pop_den,x,y from nj_djzq_jp'''
    cursor.execute(select_demands_sql)
    rs = cursor.fetchall()
    for i, row in enumerate(rs):
        try:
            objectid = row[0]
            pd=int(row[2])/1000
            pdd = row[3]
            x = row[4]
            y=row[5]
            demand = {}
            demand["demand_id"] = objectid
            demand["x"] = x
            demand["y"] = y
            demand["pd"]=pd
            demand["pdd"] = pdd
            demand["provider"]=provider_list
            mongo_operater_obj.insert_record(demand)
        except:
            continue



if __name__=="__main__":
    provider_list = initial_providers()
    mongo_operater_obj = mongo_operater.MongoOperater("test", "rtmcp_mtm_gm")
    get_all_demonds_and_save_in_mongodb(provider_list,mongo_operater_obj)

