#coding:utf-8
import sys

#计算重力模型值
import math
import numpy as np

import mongo_operater

DB_NAME="test"
COLLECTION_NAME="rtmcp_mtm_gm"


def vj_function(t_dict_list):
    vj=0.000000001
    try:
        for k in t_dict_list["demands"]:
            if k["TP_D"] != 0 and k["TP_D"]<=TP_THROD:
                vj=vj+k["TP_WEIGHT"]*k["pd"]/math.pow(k["TP_D"], TP_BEITA)
            if k["D_D"] != 0 and k["D_D"] <= D_THROD:
                vj=vj+k["D_WEIGHT"]*k["pd"]/math.pow(k["D_D"], D_BEITA)
            if k["W_D"] != 0 and k["W_D"] <= W_THROD:
                vj=vj+k["W_WEIGHT"]*k["pd"]/math.pow(k["W_D"], W_BEITA)
            if k["B_D"] != 0 and k["B_D"] <= B_THROD:
                vj=vj+k["B_WEIGHT"]*k["pd"]/math.pow(k["B_D"], B_BEITA)
        return vj/1
    except:
        return 0.00000000001


def get_provider_transportion_by_provider_id(provider_list_dict_list,provider_id):
    for provider in provider_list_dict_list:
        if provider["provider_id"]==provider_id:
            return provider
    return None

def create_vj_list(rows_json_list):
    provider_list_dict_list = []
    for demand in rows_json_list:
        try:
            demand_id = demand["demand_id"]
            demand_pd=demand["pd"]
            providers_list=demand["provider"]
            for provider in providers_list:
                provider_transposition=get_provider_transportion_by_provider_id(provider_list_dict_list,provider["provider_id"])
                if  provider_transposition==None:
                    provider_transposition={}
                    provider_transposition["provider_id"]=provider["provider_id"]
                    provider_transposition["demands"]=[]

                    demand = {}
                    demand["TP_D"] = provider["travel"]["TP_D"]
                    demand["D_D"] = provider["travel"]["D_D"]
                    demand["W_D"] = provider["travel"]["W_D"]
                    demand["B_D"] = provider["travel"]["B_D"]
                    demand["TP_WEIGHT"] = provider["softmax"]["TP"]
                    demand["D_WEIGHT"] = provider["softmax"]["D"]
                    demand["W_WEIGHT"] = provider["softmax"]["W"]
                    demand["B_WEIGHT"] = provider["softmax"]["B"]
                    demand["demand_id"] = demand_id
                    demand["pd"] = demand_pd
                    provider_transposition["demands"].append(demand)
                    provider_list_dict_list.append(provider_transposition)
                else:
                    demand = {}
                    demand["TP_D"] = provider["travel"]["TP_D"]
                    demand["D_D"] = provider["travel"]["D_D"]
                    demand["W_D"] = provider["travel"]["W_D"]
                    demand["B_D"] = provider["travel"]["B_D"]

                    demand["TP_WEIGHT"] = provider["softmax"]["TP"]
                    demand["D_WEIGHT"] = provider["softmax"]["D"]
                    demand["W_WEIGHT"] = provider["softmax"]["W"]
                    demand["B_WEIGHT"] = provider["softmax"]["B"]

                    demand["demand_id"] = demand_id
                    demand["pd"] = demand_pd
                    provider_transposition["demands"].append(demand)
        except:
            continue
    return provider_list_dict_list

"""
Calculate gravity value
"""
def calculate_gravity_value(mongo_operater_obj):

    rows_json_list = mongo_operater_obj.find_records(0, 2265)
    n_fetched = len(rows_json_list)

    provider_list_dict_list=create_vj_list(rows_json_list)
    for t_dict_list in provider_list_dict_list:
        t_dict_list["vj"]=vj_function(t_dict_list)
        print( t_dict_list["vj"])


    for demand in rows_json_list:
        if demand["demand_id"]==2206:
            print("2206")
        providers=demand["provider"]
        gravity_value=0
        for provider in providers:
            try:
                provider_id = provider["provider_id"]
                ej=provider["dc"]
                provider_transportion=get_provider_transportion_by_provider_id(provider_list_dict_list,provider_id)
                vj=provider_transportion["vj"]

                if demand["demand_id"] == 2206 :
                    print(provider["provider_id"])
                    if provider["travel"]["TP_D"] != 0 and provider["travel"]["TP_D"] <= TP_THROD:
                        gravity_value=gravity_value+provider["softmax"]["TP"]*ej/(math.pow(provider["travel"]["TP_D"], TP_BEITA) * vj)
                        print("TP",provider["softmax"]["TP"], ej/(math.pow(provider["travel"]["TP_D"], TP_BEITA) * vj) )
                    if provider["travel"]["D_D"] != 0 and provider["travel"]["D_D"] <= D_THROD:
                        gravity_value=gravity_value+provider["softmax"]["D"]*ej/(math.pow(provider["travel"]["D_D"], D_BEITA) * vj)
                        print("D",provider["softmax"]["D"], ej/(math.pow(provider["travel"]["D_D"], D_BEITA) * vj) )
                    if provider["travel"]["W_D"] != 0 and provider["travel"]["W_D"] <= W_THROD:
                        gravity_value=gravity_value+provider["softmax"]["W"]*ej/(math.pow(provider["travel"]["W_D"], W_BEITA) * vj)
                        print("W",provider["softmax"]["W"], ej/(math.pow(provider["travel"]["W_D"], W_BEITA) * vj) )
                    if provider["travel"]["B_D"] != 0 and provider["travel"]["B_D"] <= B_THROD:
                        gravity_value=gravity_value+provider["softmax"]["B"]*ej/(math.pow(provider["travel"]["B_D"], B_BEITA) * vj)
                        print("B",provider["softmax"]["B"], ej/(math.pow(provider["travel"]["B_D"], B_BEITA) * vj) )
                    print(gravity_value)
                    print("---------------------------------")
                else:
                    if provider["travel"]["TP_D"] != 0 and provider["travel"]["TP_D"] <= TP_THROD:
                        gravity_value=gravity_value+provider["softmax"]["TP"]*ej/(math.pow(provider["travel"]["TP_D"], TP_BEITA) * vj)
                    if provider["travel"]["D_D"] != 0 and provider["travel"]["D_D"] <= D_THROD:
                        gravity_value=gravity_value+provider["softmax"]["D"]*ej/(math.pow(provider["travel"]["D_D"], D_BEITA) * vj)
                    if provider["travel"]["W_D"] != 0 and provider["travel"]["W_D"] <= W_THROD:
                        gravity_value=gravity_value+provider["softmax"]["W"]*ej/(math.pow(provider["travel"]["W_D"], W_BEITA) * vj)
                    if provider["travel"]["B_D"] != 0 and provider["travel"]["B_D"] <= B_THROD:
                        gravity_value=gravity_value+provider["softmax"]["B"]*ej/(math.pow(provider["travel"]["B_D"], B_BEITA) * vj)
            except:
                print("demand point{0}，provider point {1}，don't join in accessibility calculation".format(demand["demand_id"], provider["provider_id"]))
                continue
        demand["mtm_sofmax_gravity"]=gravity_value/1
        mongo_operater_obj.update_demand_mtm_rtmcp_gravity_value(demand["mtm_sofmax_gravity"],demand["demand_id"])



# BEITA=0.8
W_BEITA=1.4
B_BEITA=1.2
TP_BEITA=1.0
D_BEITA=0.8
W_THROD=60
B_THROD=80
TP_THROD=100
D_THROD=120
if __name__=="__main__":
    mongo_operater_obj = mongo_operater.MongoOperater(DB_NAME, COLLECTION_NAME)
    calculate_gravity_value(mongo_operater_obj)
    mongo_operater_obj.close()





