#coding:utf-8
import math
import mongo_operater

DB_NAME="test"
COLLECTION_NAME="rtmcp_mtm_gm"


def vj_function(t_dict_list):
    vj=0.000000001
    try:
        for k in t_dict_list["demands"]:
            if k["TP_D"] != 0 and k["TP_D"]<=THROD:
                vj=vj+k["pd"]/math.pow(k["TP_D"],BEITA)
        return vj
    except:
        return 0.00000000001


def get_provider_transportion_by_provider_id(provider_list_dict_list,provider_id):
    for provider in provider_list_dict_list:
        if provider["provider_id"]==provider_id:
            return provider
    return None

def create_vj_list(rows_json_list):
    provider_list_dict_list = []
    for demand in rows_json_list:
        try:
            demand_id = demand["demand_id"]
            demand_pd=demand["pd"]
            providers_list=demand["provider"]
            for provider in providers_list:
                provider_transposition=get_provider_transportion_by_provider_id(provider_list_dict_list,provider["provider_id"])
                if  provider_transposition==None:
                    provider_transposition={}
                    provider_transposition["provider_id"]=provider["provider_id"]
                    provider_transposition["demands"]=[]

                    demand = {}
                    demand["TP_D"] = provider["travel"]["TP_D"]
                    demand["demand_id"] = demand_id
                    demand["pd"] = demand_pd
                    provider_transposition["demands"].append(demand)

                    provider_list_dict_list.append(provider_transposition)
                else:
                    demand = {}
                    demand["TP_D"] = provider["travel"]["TP_D"]
                    demand["demand_id"] = demand_id
                    demand["pd"] = demand_pd
                    provider_transposition["demands"].append(demand)
        except:
            continue
    return provider_list_dict_list

"""
Calculate gravity value
"""
def calculate_gravity_value(mongo_operater_obj):
    rows_json_list = mongo_operater_obj.find_records(0, 2265)
    n_fetched = len(rows_json_list)
    provider_list_dict_list=create_vj_list(rows_json_list)
    for t_dict_list in provider_list_dict_list:
        # if t_dict_list["provider_id"]==1671:
        #     print(1671)
        t_dict_list["vj"]=vj_function(t_dict_list)
        print(t_dict_list["provider_id"], t_dict_list["vj"])
    for demand in rows_json_list:
        providers=demand["provider"]
        gravity_value=0
        for provider in providers:
            try:
                provider_id = provider["provider_id"]
                ej=provider["dc"]
                provider_transportion=get_provider_transportion_by_provider_id(provider_list_dict_list,provider_id)
                dij=provider["travel"]["TP_D"]
                vj=provider_transportion["vj"]
                if dij<=THROD:
                    gravity_value=gravity_value+ej/(math.pow(dij,BEITA)*vj)
            except:
                print("demand point{0}，provider point {1}，don't join in accessibility calculation".format(demand["demand_id"], provider["provider_id"]))
                continue
        demand["single_gravity"]=gravity_value
        mongo_operater_obj.update_demand_gravity_value(demand["single_gravity"],demand["demand_id"])



BEITA=1

THROD=100
if __name__=="__main__":
    mongo_operater_obj = mongo_operater.MongoOperater(DB_NAME, COLLECTION_NAME)
    calculate_gravity_value(mongo_operater_obj)
    mongo_operater_obj.close()





