#coding:utf-8
import math
import numpy as np
from sklearn import preprocessing
import mongo_operater

DB_NAME="test"
COLLECTION_NAME="rtmcp_mtm_gm"

"""
In mathematics, especially probability theory and related fields, 
Softmax function, or normalized index function, is an extension of logic function.
use Softmax function
 """
def softmax_function(t_list):
    try:
        z_exp = [math.exp(i) for i in t_list]
        sum_z_exp = sum(z_exp)
        softmax_list = [round(i / sum_z_exp, 3) for i in z_exp]
        return np.array(softmax_list)
    except:
        return


"""
Considering the cost factor；
Normalize results or remove mean and variance scaling
 """
def calculate_softmax_probability_z_score(provider,is_Litman=True):
    if is_Litman:
        std_provider_list = np.sqrt(np.array([provider["travel"]["TP_D"] * provider["travel"]["TP_T"] * 1.08 * 1.08,
                                              provider["travel"]["D_D"] * provider["travel"]["D_T"] * 1.15 * 1.15,
                                              provider["travel"]["W_D"] * provider["travel"]["W_T"] * 1.01 * 1.01,
                                              provider["travel"]["B_D"] * provider["travel"]["B_T"] * 1.03 * 1.03]))
    else:
        std_provider_list = np.sqrt(np.array([provider["travel"]["TP_D"] * provider["travel"]["TP_T"] * 1.067 * 1.067,
                                              provider["travel"]["D_D"] * provider["travel"]["D_T"] * 1.754 * 1.754,
                                              provider["travel"]["W_D"] * provider["travel"]["W_T"] * 1.00 * 1.00,
                                              provider["travel"]["B_D"] * provider["travel"]["B_T"] * 1.03 * 1.03]))
    print("std_provider_list", std_provider_list)
    std_provider_list_z_score = preprocessing.scale(1 / std_provider_list)
    print("z_score",std_provider_list_z_score)
    softmax_probability_provider_list = softmax_function(std_provider_list_z_score)
    print("SOFTMAX probability", softmax_probability_provider_list)
    return softmax_probability_provider_list


"""
From Nanjing Yujingli to GZ-NCH
 """
def test_yujinli_OD():
    yujinyuan_od_provider_13 = {}
    yujinyuan_od_provider_13["travel"] = {}
    yujinyuan_od_provider_13["travel"]["TP_D"] = 28.6
    yujinyuan_od_provider_13["travel"]["TP_T"] =1.18
    yujinyuan_od_provider_13["travel"]["D_D"] = 23.1
    yujinyuan_od_provider_13["travel"]["D_T"] = 0.75
    yujinyuan_od_provider_13["travel"]["W_D"] = 21.1
    yujinyuan_od_provider_13["travel"]["W_T"] = 5.35
    yujinyuan_od_provider_13["travel"]["B_D"] = 23
    yujinyuan_od_provider_13["travel"]["B_T"] = 2.0
    print("z_score")
    print("is_Litman=True")
    calculate_softmax_probability_z_score(yujinyuan_od_provider_13,is_Litman=True)

# if __name__=="__main__":
    # test_yujinli_OD()


if __name__=="__main__":
    mongo_operater_obj = mongo_operater.MongoOperater(DB_NAME, COLLECTION_NAME)
    n_fetched = 0
    rows_json_list = mongo_operater_obj.find_records(0, 2265)
    n_fetched = len(rows_json_list)
    for demand in rows_json_list:
        providers_json_list = demand["provider"]
        for item_provider in providers_json_list:
            #TP  D  W  B
            softmax_probability_provider_list = calculate_softmax_probability_z_score(item_provider, is_Litman=True)
            softmax_probability={"TP":softmax_probability_provider_list[0],"D":softmax_probability_provider_list[1],
                                 "W":softmax_probability_provider_list[2],"B":softmax_probability_provider_list[3]}
            mongo_operater_obj.update_provider_travel_softmax_probability_record(softmax_probability, demand["demand_id"],item_provider["provider_id"])




