from pymongo import MongoClient
import json
"""
This is MongoDB operter.
"""
class MongoOperater:
    def __init__(self,db_name,collection_name):
        self.client = MongoClient(host='localhost', port=27017)
        self.db = self.client[db_name]
        self. collection = self.db[collection_name]
    """
   Function: Close
    """
    def close(self):
        self.client.close()

    """
     Function: Insert an object into the database
    """
    def insert_record(self,json_object):
        result = self.collection.insert(json_object)
        print("OK")

    """
      Function: Looks for a collection of objects in a specific location segment
    """
    def find_records(self,begin_counter,end_counter):
        records=self.collection.find().sort([("demand_id",1)])
        records_list = list(records)[begin_counter:end_counter]
        return records_list

    """
      Function:  Find an object with a specific demand id
    """
    def find_one_record_by_demand_id(self, demand_id):
        records = self.collection.find({"demand_id":demand_id})
        records_list = list(records)[0:1]
        return records_list

    """
     Function: Find the demand object for a specific demand id
    """
    def find_record_by_demand_id(self,demand_id):
        return self.collection.find({"demand_id":demand_id})
    """
     Function:  Update the value of the provider List for a specific demand object
    """
    def update_provider_records(self, provider_json_object_list, demand_id_value):
        self.collection.update({'demand_id':demand_id_value}, {"$set":{'provider': provider_json_object_list}})
    """
    Function: Update the value of the Travel for a specific provider object
    """
    def update_provider_travel_record(self, travel, demand_id, provider_id_value):
        self.collection.update({"demand_id":demand_id,'provider.provider_id': provider_id_value}, {"$set": {'provider.$.travel': travel}})


    """
    Function:  Update the value of the softmax problility weights for a specific provider object
    """
    def update_provider_travel_softmax_probability_record(self, softmax_probability, demand_id, provider_id_value):
        self.collection.update({"demand_id":demand_id,'provider.provider_id': provider_id_value}, {"$set": {'provider.$.softmax': softmax_probability}})


    """
    Function:  Update the value of the gravity for a specific demand object
    """
    def update_demand_gravity_value(self, gravity_value, demand_id):
        self.collection.update({"demand_id": demand_id},{"$set": {'gravity_value': gravity_value}})

    """
   Function:  Update the value of the gravity for a specific demand object
    """
    def update_demand_mtm_gravity_value(self, gravity_value, demand_id):
        self.collection.update({"demand_id": demand_id}, {"$set": {'mtm_gravity_value': gravity_value}})

    """
    Function: Update the value of the gravity for a specific demand object
    """
    def update_demand_mtm_rtmcp_gravity_value(self, gravity_value, demand_id):
        self.collection.update({"demand_id": demand_id}, {"$set": {'mtm_rtmcp_gravity_value': gravity_value}})

    """
   Function: Update the value of the gravity for a specific demand object
    """
    def update_demand_gravity_value_cipf_denstiy(self, gravity_value_cipf_denstiy, demand_id):
        self.collection.update({"demand_id": demand_id}, {"$set": {'gravity_value_cipf_denstiy': gravity_value_cipf_denstiy}})


    """
    Function: Update the value of the gravity for a specific provider object
    """
    def update_provider_cipf_density_value(self, cipf_density, provider_id,demand_id):
        self.collection.update({"demand_id": demand_id, 'provider.provider_id': provider_id},
                               {"$set": {'provider.$.cipf_density': cipf_density}})

    """
    Function: Update the value of the pdd for a specific demand object
    """
    def update_demand_pdd_value(self, pdd, demand_id):
        self.collection.update({"demand_id": demand_id},{"$set": {'pdd': pdd}})

    """
    Function: Update the value of the Travel for a specific provider object
    """
    def update_provider_softmax(self, travel, demand_id, provider_id_value):
        self.collection.update({"demand_id": demand_id, 'provider.provider_id': provider_id_value},
                               {"$set": {'provider.$.travel': travel}})

